﻿function calcPoissMorts()
{
	var coefRiv=nitratesRiv/100;
	var coefHerbRiv=1/(1+desherbant/5);
	cNenuMax=Math.floor((0.2+coefRiv*coefHerbRiv*0.8)*100);
	
	cNenuMax=cNenuMax
	
	coefRiv=(nitratesRiv-50)/100;
	cPoissMortsMax=Math.floor(coefRiv*100);	
	if (cPoissMortsMax<0) {cPoissMortsMax=0;}
	if (pesticidesEau>3)
	{
		cPoissMortsMax=cPoissMortsMax+(pesticidesEau-3)*2;
	}
}

function calcConsoEau ()
{
	consoEau=0;
	var pompe=false;
	// on recherche si une pompe est réellement présente 
	for (var i=0;i<iobj[10].tpos.length;i++)
	{
		if (iobj[10].tpos[i].p)
		{
			pompe=true;
		}
	}
	
	for (var i=0;i<iobj[1].tpos.length;i++)
	{
		var t=iobj[1].tpos[i];
		if (t.espece==1)
		{
			if ((t.p)&&(!t.souche)&&(t.etat>0)&&(t.vit>0))
			{
				var nappe=(500-alt_case(t.x,t.y))/5;
				if (nappe<0) {nappe=0;}
				//console.log ('nappe='+nappe);
				var haut=t.haut;
				// un arbre jeune boit plus
				var surcons=(5-t.age);
				if (surcons<1) {surcons=1;}
				
				var besoins=haut*surcons/10;
				var conso=besoins-nappe;
				//console.log ('besoins='+besoins);
				//console.log ('conso='+conso+" consoEau="+consoEau);
				if (conso<0) {conso=0;}
				consoEau+=conso;
				
			}//fin arbre présent et pas déjà en souche
		}// fin espece 1
	}//next i
	if (pompe) {consoEau-=1000;}
	if (consoEau<0) {consoEau=0;}
	consoEau=Math.round(consoEau);
}

function analyserEau ()
{
	nQuestion=-2;
	enTeteQuestion();
	
	ht=Math.floor(hcanvq/22);
	
	ctxq.textAlign="left";

	argent-=150;
	depenses+=150;

	ctxq.font = "bold "+ht*1.5+"px sans-serif";
	var texte1="Résultats de l'analyse de l'eau de la rivière";
	var yt=wrapText(ctxq, texte1, ht*3, ht*5, lcanvq-ht*6, ht*2);
	ctxq.font =ht*1.25+"px sans-serif";
	
	couleur="117711";
	if (nitratesRiv>20) {couleur="BB9933";}
	if (nitratesRiv>50) {couleur="BB3333";}
	ctxq.fillStyle="#"+couleur;
	
	var texte1="Le taux de nitrates est de "+Math.round(nitratesRiv)+" mg/L";
	var yt=wrapText(ctxq, texte1, ht*4, yt+ht*3, lcanvq-ht*6, ht*1.5);
	
	couleur="117711";
	if (pesticidesEau>4) {couleur="BB9933";}
	if (pesticidesEau>8) {couleur="BB3333";}
	ctxq.fillStyle="#"+couleur;
	var texte2="Le taux de pesticides est de "+Math.round(pesticidesEau)+" UA";
	var yt=wrapText(ctxq, texte2, ht*4, yt+ht*3, lcanvq-ht*6, ht*1.5);
}

function verifieCrue (id)
{
	//vérifie si les objets id sont emportés par la crue
	var t=iobj[id].tpos;
	for (var i=0;i<t.length;i++)
	{
		var t2=iobj[id].tpos[i];
		if (alt_case(t2.x,t2.y)<0)
		{
			supprObjet(id,i);
		}
	}

}

function decrue()
{
		nivCrue--;
		nivCrue=Math.round(nivCrue);
		if (nivCrue<(-0.5)) {nivCrue=0;return false;}
		for (i=0;i<=imax+1;i++)
		{
			for (j=0;j<=jmax+1;j++)
			{
				tz[i][j]+=flood0;
			}
		}
		ypos+=flood0/25;
}

function crue(niv)
{
		//console.log ('crue');
		nivCrue=niv;
		flood=flood0*niv;
		for (i=0;i<=imax+1;i++)
		{
			for (j=0;j<=jmax+1;j++)
			{
				tz[i][j]-=flood;
			}
		}
		ypos-=flood/25;
		verifieCrue (9); //ruches
		verifieCrue (13); //épouvantail
		verifieCrue (15); //composteur
}


function hexableu (a,b,c,d,e,f)
{
			
			ctx.beginPath();
			ctx.moveTo(a.x,a.y);
			ctx.lineTo(b.x,b.y);
			ctx.lineTo(c.x,c.y);
			ctx.lineTo(d.x,d.y);
			ctx.lineTo(e.x,e.y);
			ctx.lineTo(f.x,f.y);
			ctx.closePath();
			ctx.fill();
}

function pentableu (a,b,c,d,e)
{
			
			ctx.beginPath();
			ctx.moveTo(a.x,a.y);
			ctx.lineTo(b.x,b.y);
			ctx.lineTo(c.x,c.y);
			ctx.lineTo(d.x,d.y);
			ctx.lineTo(e.x,e.y);
			ctx.closePath();
			ctx.fill();
}

function tetrableu (a,b,c,d)
{
			
			ctx.beginPath();
			ctx.moveTo(a.x,a.y);
			ctx.lineTo(b.x,b.y);
			ctx.lineTo(c.x,c.y);
			ctx.lineTo(d.x,d.y);
			ctx.closePath();
			ctx.fill();
}

function tribleu (a,b,c)
{
		
			ctx.beginPath();
			ctx.moveTo(a.x,a.y);
			ctx.lineTo(b.x,b.y);
			//console.log ("c="+c.x+" "+c.y);
			ctx.lineTo(c.x,c.y);
			ctx.lineTo(a.x,a.y);
			ctx.closePath();
			ctx.fill();
}

function milieu_pond (a,b)
{
	var c=new Object ();
	if (((a.z>=0)&&(b.z>=0))||((a.z<=0)&&(b.z<=0)))
	{
		c.x=(a.x+b.x)/2;
		c.y=(a.y+b.y)/2;
		return c;
	}
	
	c.x=(a.x*b.z-b.x*a.z)/(b.z-a.z);
	c.y=(a.y*b.z-b.y*a.z)/(b.z-a.z);
	return c;

}

function case_eau(i,j)
{
			var dx=50/zf;
			var dy=25/zf;
			x=x0+i*(50/zf)-j*(50/zf);
			x+=xpos*50/zf;
			y=y0+j*(25/zf)+i*(25/zf);
			y+=ypos*25/zf;

			var a=new Object ();
			var b=new Object ();
			var c=new Object ();
			var d=new Object ();
			var a0=new Object();
			var b0=new Object();
			var c0=new Object();
			var d0=new Object();
			
			a.x=x;
			b.x=x+dx;
			c.x=x;
			d.x=x-dx;
			a.z=tz[i][j]/zf;
			b.z=tz[i+1][j]/zf;
			c.z=tz[i+1][j+1]/zf;
			d.z=tz[i][j+1]/zf;
			a.y=y-a.z;
			b.y=y+dy-b.z;
			c.y=y+2*dy-c.z;
			d.y=y+dy-d.z;
			
			a0.x=a.x;
			b0.x=b.x;
			c0.x=c.x;
			d0.x=d.x;
			a0.z=a.z;
			b0.z=b.z;
			c0.z=c.z;
			d0.z=d.z;
			
			if (a0.z<0) {a0.z=0;}
			if (b0.z<0) {b0.z=0;}
			if (c0.z<0) {c0.z=0;}
			if (d0.z<0) {d0.z=0;}
			
			a0.y=y-a0.z;
			b0.y=y+dy-b0.z;
			c0.y=y+2*dy-c0.z;
			d0.y=y+dy-d0.z;
			
		
			var ab=new Object ();
			var bc=new Object ();
			var cd=new Object ();
			var da=new Object ();
			
			ab=milieu_pond(a,b);
			bc=milieu_pond(b,c);
			cd=milieu_pond(c,d);
			da=milieu_pond(d,a);
			
			var vert=Math.round(nitratesRiv);
			if (vert>100) {vert=100;}
			var bleu=200-vert;

			couleur="rgba(0,"+vert+","+bleu+",0.3)";
			ctx.fillStyle=couleur;
						
			if ((i==imax)&&(c.z<0)&&(b.z<0))
			{
				tetrableu(c,c0,b0,b);
				tetrableu(c,c0,b0,b);
			}
			
			if ((j==jmax)&&(c.z<0)&&(d.z<0))
			{
				tetrableu(c,c0,d0,d);
				tetrableu(c,c0,d0,d);
			}
						
			if ((a.z<=0)&&(b.z<=0)&&(c.z<=0)&&(d.z<=0))
			{
				tetrableu (a0,b0,c0,d0);
				return false;
			}
			

			// cas bizarres en papillon
			if ((a.z>=0)&&(c.z>=0)&&(b.z<0)&&(d.z<0)) //A&C
			{
				hexableu (d0,da,ab,b0,bc,cd);
				return false;
			}
			
			if ((b.z>=0)&&(d.z>=0)&&(a.z<0)&&(c.z<0)) //B&D
			{
				hexableu (a0,ab,bc,c0,cd,da);
				return false;
			}
			

			if ((a.z>=0)&&(b.z>=0)&&(c.z<0)&&(d.z<0)) //AB
			{

				tetrableu(da,d0,c0,bc);
				return false;
			}
			
			if ((d.z>=0)&&(c.z>=0)&&(a.z<0)&&(b.z<0)) //CD
			{

				tetrableu(da,a0,b0,bc);
				return false;
			}
			
			if ((d.z>=0)&&(a.z>=0)&&(c.z<0)&&(b.z<0)) //DA
			{

				tetrableu(c0,cd,ab,b0);
				return false;
			}
			
			if ((c.z>=0)&&(b.z>=0)&&(a.z<0)&&(d.z<0)) //BC
			{

				tetrableu(d0,a0,ab,cd);
				return false;
			}
			
			// juste un coin hors de l'eau
			if ((a.z>=0)&&(b.z<0)&&(c.z<0)&&(d.z<0)) //A
			{

				pentableu(ab,b0,c0,d0,da);
				return false;
			}
			
			if ((b.z>=0)&&(a.z<0)&&(c.z<0)&&(d.z<0))
			{

				pentableu(bc,c0,d0,a0,ab);
				return false;
			}
			
			if ((c.z>=0)&&(a.z<0)&&(b.z<0)&&(d.z<0))
			{

				pentableu(cd,d0,a0,b0,bc);
				return false;
			}
			
			if ((d.z>=0)&&(a.z<0)&&(b.z<0)&&(c.z<0))
			{

				pentableu(da,a0,b0,c0,cd);
				return false;
			}
			
			// un coin sous l'eau
			if ((a.z>=0)&&(b.z>=0)&&(d.z>=0)&&(c.z<0))
			{

				tribleu(bc,c0,cd);
				return false;
			}
			
			if ((b.z>=0)&&(a.z>=0)&&(c.z>=0)&&(d.z<0))
			{

				tribleu(cd,d0,da);
				return false;
			}	
			
			if ((b.z>=0)&&(d.z>=0)&&(c.z>=0)&&(a.z<0))
			{

				tribleu(da,a0,ab);
				return false;
			}
			
			if ((a.z>=0)&&(d.z>=0)&&(c.z>=0)&&(b.z<0))
			{

				tribleu(ab,b0,bc);
				return false;
			}		
			
			
}